unit ControlPanel;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Spin;

type
  TControl_Panel = class(TForm)
    Button1: TButton;
    Button2: TButton;
    StaticText1: TStaticText;
    Button3: TButton;
    StaticText9: TStaticText;
    StaticText10: TStaticText;
    SpinEdit1: TSpinEdit;
    procedure ClearImage(Sender: TObject);
    procedure Draw(Sender: TObject);
    procedure Finish(Sender: TObject);
    procedure SetDraw2D(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Control_Panel: TControl_Panel;

implementation

uses Graph2d_256_Approx;

{$R *.DFM}

procedure TControl_Panel.ClearImage(Sender: TObject);
begin
  With Draw2D do
  begin
  ClearImage(slWhite);
  XScaled(x1,x2,0,clRed);YScaled(y1,y2,0,clRed);
  end;
  index:=0;
 end;

procedure TControl_Panel.Draw(Sender: TObject);
var a     :array [0..10,0..10] of Extended;
    b,c   :array [0..10] of Extended;
    n,Code,HustotaKrivky:Integer;
    hx    :Real;
    i,j   :Integer;
    Q     :TArrayOfPoints;

  Function Power(Basis:Real;Exponent:Integer):Extended;
  var Pow:Extended;
      i:Integer;
  begin
    Pow:=1;
    if abs(Exponent)>0 then
       for i:=1 to Abs(Exponent) do Pow:=Pow*Basis;
    if Exponent<0 then Pow:=1/Pow;
    Power:=Pow;
  end;

  Procedure GenerOfSystem;
  var i,j,k:Integer;
      x,y:array [1..100] of Extended;
  begin
    for k:=0 to index-1 do
    begin x[k]:=P[k,1];y[k]:=P[k,2];end;
    for i:=0 to n do for j:=0 to n do a[i,j]:=0;
    for i:=0 to n do begin b[i]:=0;c[i]:=0;end;
    For i:=0 to n do
      begin
        for j:=0 to n do
          for k:=0 to index-1 do
            a[n-i,n-j]:=a[n-i,n-j]+Power(x[k],i+j);
        For k:=0 to index-1 do
        b[n-i]:=b[n-i]+y[k]*Power(x[k],i);
      end;
  end;

  procedure Elimination;
    var i,j,k,l,r:Integer;
        Trezor:Extended;
    begin
      {****  Gaussova elimin. metoda **********}
       for i:=0 to n-1 do                    {Postup po hl. diagonale}
       begin
           if abs(a[i,i])<1e-8 then          {Na hl. diagonale nula}
       begin
        l:=i;
        Repeat                               {Nalezeni nenuloveho prvku}
           l:=succ(l);
        until (a[l,i]<>0) or (l=n);
        if (a[i,i]=0) and (i=n) then exit;   {Nenulovy prvek nenalezen}
        for r:=i to n do                     {Prehozeni radku}
           begin
             Trezor:=a[l,r];a[l,r]:=a[i,r];
             a[i,r]:=Trezor;
           end;                              {Prehozeni radku}
        Trezor:=b[l];b[l]:=b[i];b[i]:=Trezor;{Prehozeni pravych stran}
       end;                                  {Na hl. diagonale nula}
       for k:=i+1 to n do                    {Nulovani pod a[i,i]}
       begin
         Trezor:=a[k,i]/a[i,i];
         for j:=i to n do
            a[k,j]:=a[k,j]-Trezor*a[i,j];
         b[k]:=b[k]-Trezor*b[i];             {Eliminace prave strany}
      end;                                   {Nulovani pod a[i,i]}
    end;                                     {Postup po hl. diagonale}
{*** Zpetny chod **********}
    if a[n,n]=0 then exit;
    for i:=0 to n do c[i]:=0;
    c[n]:=b[n]/a[n,n];
    for i:=n-1 downto 0 do                   {Zpet po hl. diaginale}
    begin
      for j:=i+1 to n do
          c[i]:=c[i]+a[i,j]*c[j];            {Secteni radku}
       c[i]:=(b[i]-c[i])/a[i,i];             {vypocet i-te slozky reseni}
    end;                                     {Zpet po hl. diagonale}
  end;

begin
  n:=SpinEdit1.Value;
  GenerOfSystem;Elimination;
  HustotaKrivky:=200;
  With Draw2D do
   begin Q[0,1]:=x1;hx:=(x2-x1)/HustotaKrivky;end;
  For i:=1 to HustotaKrivky do Q[i,1]:=Q[i-1,1]+hx;
  for i:=0 to HustotaKrivky do Q[i,2]:=0;
  for i:=0 to HustotaKrivky do
    for j:=0 to n do Q[i,2]:=Q[i,2]+c[n-j]*Power(Q[i,1],j);
  Draw2D.PolyLine(Q,HustotaKrivky,slBlue);
  Draw2D.Image1.Repaint;
end;


procedure TControl_Panel.Finish(Sender: TObject);
begin
  Draw2D.Visible:=False;Halt;
end;

procedure TControl_Panel.SetDraw2D(Sender: TObject);
begin
 Application.CreateForm(TDraw2D, Draw2D);
 With Draw2D do
 begin
    InitImage(500,500);ClearImage(slWhite);
    Caption:=' Aproximace metodou nejmench tverc';
    Visible:=True;
   x1:=-5;x2:=5;y1:=-6;y2:=6;Scale(x1,x2,y1,y2);
   XScaled(x1,x2,0,clRed);YScaled(y1,y2,0,clRed);
   index:=0;
  end;

end;


end.
