unit ControlPanel;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls, Spin, Grids;

type
  TControl_Panel = class(TForm)
    SpinEdit1: TSpinEdit;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    StringGrid1: TStringGrid;
    Edit1: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    EditDX1: TEdit;
    EditDX2: TEdit;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    EditX1: TEdit;
    EditX2: TEdit;
    EditY1: TEdit;
    EditY2: TEdit;
    Label7: TLabel;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    Label8: TLabel;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    Shape1: TShape;
    Shape2: TShape;
    Shape3: TShape;
    StaticText4: TStaticText;
    StaticText3: TStaticText;
    SpinEdit2: TSpinEdit;
    Label9: TLabel;
    procedure ClearImage(Sender: TObject);
    procedure Finish(Sender: TObject);
    procedure Interpolation(Sender: TObject);
    procedure SetDraw2D(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure SpinEdit1Change(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Control_Panel: TControl_Panel;

implementation

uses Graph2D_Inter;

{$R *.DFM}

procedure TControl_Panel.ClearImage(Sender: TObject);
begin
  With Draw2D do
  begin
    ClearImage(255,255,255);
    XScale(x1,x2,0,200,0,0);
    YScale(y1,y2,0,200,0,0);
  end;
  index:=0;
end;

procedure TControl_Panel.Finish(Sender: TObject);
begin
  Draw2D.Visible:=False;halt;
end;

procedure TControl_Panel.Interpolation(Sender: TObject);
var i,j,n,kk      :Integer;
    xx,yy         :array [0..20] of real;
    DfX1,DfX2     :Real;
    Red,Green,Blue:Byte;
    HustotaKrivky :Integer;
    Error         :Integer;
    VypisChyby    :String;
    ux,uy        :array [0..50] of real;
    h            :array [1..50] of Real;
    M            :array [0..50] of Real;
    a     :array [0..10,0..10] of Extended;
    b,c   :array [0..10] of Extended;

  {  Function Mocnina(zaklad:Real;Exponent:Integer):Real;
    var Moc    :Extended;
        i,Exp  :Integer;
    begin
      Exp:=Abs(Exponent);Moc:=Zaklad;
      if Exp<>0 then for i:=1 to Exp do Moc:=Moc*Zaklad;
      if Exponent<0 then Moc:=1/Moc;
      Mocnina:=Moc;
    end; }

  Function Power(Basis:Real;Exponent:Integer):Extended;
  var Pow:Extended;
      i:Integer;
  begin
    Pow:=1;
    if abs(Exponent)>0 then
       for i:=1 to Abs(Exponent) do Pow:=Pow*Basis;
    if Exponent<0 then Pow:=1/Pow;
    Power:=Pow;
  end;

  Procedure GenerOfSystem;
  var i,j,k:Integer;
      x,y:array [1..100] of Extended;
  begin
    for k:=0 to index-1 do
    begin x[k]:=Draw2D.P[k,1];y[k]:=Draw2D.P[k,2];end;
    for i:=0 to n do for j:=0 to n do a[i,j]:=0;
    for i:=0 to n do begin b[i]:=0;c[i]:=0;end;
    For i:=0 to n do
      begin
        for j:=0 to n do
          for k:=0 to index-1 do
            a[n-i,n-j]:=a[n-i,n-j]+Power(x[k],i+j);
        For k:=0 to index-1 do
        b[n-i]:=b[n-i]+y[k]*Power(x[k],i);
      end;
  end;

  procedure Elimination;
    var i,j,k,l,r:Integer;
        Trezor:Extended;
    begin
      {****  Gaussova elimin. metoda **********}
       for i:=0 to n-1 do                    {Postup po hl. diagonale}
       begin
           if abs(a[i,i])<1e-8 then          {Na hl. diagonale nula}
       begin
        l:=i;
        Repeat                               {Nalezeni nenuloveho prvku}
           l:=succ(l);
        until (a[l,i]<>0) or (l=n);
        if (a[i,i]=0) and (i=n) then exit;   {Nenulovy prvek nenalezen}
        for r:=i to n do                     {Prehozeni radku}
           begin
             Trezor:=a[l,r];a[l,r]:=a[i,r];
             a[i,r]:=Trezor;
           end;                              {Prehozeni radku}
        Trezor:=b[l];b[l]:=b[i];b[i]:=Trezor;{Prehozeni pravych stran}
       end;                                  {Na hl. diagonale nula}
       for k:=i+1 to n do                    {Nulovani pod a[i,i]}
       begin
         Trezor:=a[k,i]/a[i,i];
         for j:=i to n do
            a[k,j]:=a[k,j]-Trezor*a[i,j];
         b[k]:=b[k]-Trezor*b[i];             {Eliminace prave strany}
      end;                                   {Nulovani pod a[i,i]}
    end;                                     {Postup po hl. diagonale}
{*** Zpetny chod **********}
    if a[n,n]=0 then exit;
    for i:=0 to n do c[i]:=0;
    c[n]:=b[n]/a[n,n];
    for i:=n-1 downto 0 do                   {Zpet po hl. diaginale}
    begin
      for j:=i+1 to n do
          c[i]:=c[i]+a[i,j]*c[j];            {Secteni radku}
       c[i]:=(b[i]-c[i])/a[i,i];             {vypocet i-te slozky reseni}
    end;                                     {Zpet po hl. diagonale}
  end;

begin
  With Draw2D do
       begin
        ClearImage(255,255,255);
        Val(EditX1.Text,x1,Error);
        Val(EditX2.Text,x2,Error);
        Val(EditY1.Text,y1,Error);
        Val(EditY2.Text,y2,Error);
        Scale(x1,x2,y1,y2);
       XScale(x1,x2,0,200,0,0);YScale(y1,y2,0,200,0,0);
       end;

 if radiobutton2.Checked then begin
                               n:=index;
                               if n<succ(SpinEdit2.Value) then
                               begin
                                 ShowMessage('Nen zadn dostatek bod');
                                 n:=0;index:=0;
                                 exit;
                               end;
                              end
                        else With Draw2D do
                             begin
                             n:=Spinedit1.Value;
                             for i:=0 to n-1 do
                                  begin
                                    Val(Stringgrid1.Cells[succ(i),0],P[i,1],Error);
                                    Val(Stringgrid1.Cells[succ(i),1],P[i,2],Error);
                                  end;
                             end;
  if CheckBox1.Checked then
                              With Draw2D do
                               begin
                               ClearImage(255,255,255);
                               XScale(x1,x2,0,200,0,0);
                               YScale(y1,y2,0,200,0,0);
                                for i:=0 to n-1 do
                                  Cross(P[i],10,0,150,0);
                              end;

 {Sestrojeni MNC}
 if CheckBox3.Checked then
 begin
  if RadioButton1.Checked then index:=SpinEdit1.Value;
  n:=SpinEdit2.Value;
  if Index=0 then
          begin messagedlg('Set Points by Mouse!',mterror,[mbok],0);exit;end;
  With Draw2d do hx:=(x2-x1)/200;
  GenerOfSystem;
  Elimination;
  HustotaKrivky:=200;
  With Draw2D do
   begin Q[0,1]:=x1;hx:=(x2-x1)/HustotaKrivky;end;
  For i:=1 to HustotaKrivky do Q[i,1]:=Q[i-1,1]+hx;
  for i:=0 to HustotaKrivky do Q[i,2]:=0;
  for i:=0 to HustotaKrivky do
    for j:=0 to n do Q[i,2]:=Q[i,2]+c[n-j]*Power(Q[i,1],j);
  With Draw2D do
  begin
  PolyLine(Q,HustotaKrivky,Red,Green,Blue);
     Image1.Repaint;
  end;
  index:=0;
  end;

  {sestrojeni funkce}

  if CheckBox2.Checked then
    With Draw2D do
      begin
        Val(EditDX1.Text,Dfx1,Error);
        Val(EditDX2.Text,Dfx2,Error);
        x:=Dfx1;hx:=(Dfx2-Dfx1)/200;i:=0;
        Repeat
          Q[i,1]:=x;Q[i,2]:=Calc(Edit1.Text,VypisChyby);
          if VypisChyby<>'' then begin
                              Showmessage(VypisChyby);
                              exit;
                            end;
          x:=x+hx;inc(i);
        until x>Dfx2;
        Polyline(Q,i,150,0,0);
      end;

end;

procedure TControl_Panel.SetDraw2D(Sender: TObject);
begin
  Application.CreateForm(TDraw2D, Draw2D);
  With Draw2D do
  begin
    InitImage(500,500);ClearImage(255,255,255);
    Caption:='Aproximace funkce polynomem';
    Visible:=True;
    x1:=-3;x2:=3;y1:=-1;y2:=6;Scale(x1,x2,y1,y2);
    XScale(x1,x2,0,200,0,0);
    YScale(y1,y2,0,200,0,0);
    index:=0;Red:=0;Green:=0;Blue:=200;
  end;
  With StringGrid1 do
   begin
     ColCount:=6;
     Cells[0,0]:='x(i)';Cells[1,0]:='-2';Cells[2,0]:='-1';Cells[3,0]:='0';Cells[4,0]:='1';Cells[5,0]:='2';
     Cells[0,1]:='y(i)';Cells[1,1]:= '5.1';Cells[2,1]:='1.9';Cells[3,1]:='1.1';Cells[4,1]:='2.1';Cells[5,1]:='4.9';
   end;
end;
procedure TControl_Panel.Button2Click(Sender: TObject);
begin
  Application.Terminate;
end;

procedure TControl_Panel.SpinEdit1Change(Sender: TObject);
begin
  StringGrid1.ColCount:=succ(Spinedit1.Value);
end;

end.
