unit Graph2D_Inter;

{***** pouito ScanLine *******}


interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls;

type

  TPixel         = array [1..2] of Integer;
  TPoint         = array [1..3] of Double;
  TArrayOfPoints = array [0..800] of TPoint;
  TMatrix   = array [1..3,1..3] of Double;
  TVector   = array [1..3]      of Double;
  
  TTerm = record
               Character:Char;
               Value    :Double;
             end;
  TExpression = array [0..255] of TTerm;

  TDraw2D = class(TForm)
    Panel1: TPanel;
    Image1: TImage;
    procedure SetPoint(Sender: TObject; Button: TMouseButton;Shift: TShiftState; X, Y: Integer);
  private
    { Private declarations }

      PointOnScanRow: PByteArray;

  public
  { Public declarations }
    Red,Green,Blue:Byte;
    P:TArrayOfPoints; 
    {Nastaven velikosti obrazu a hloubky pixelu}
    Procedure InitImage(Width,Height:Integer);
    {nastaven barvy z barevnch sloek}
    Procedure ClearImage(Red,Green,Blue:Byte);
    {Nastaven uivatelskch rozmr kreslc plochy}
    procedure Scale(x1,x2,y1,y2:Double);
    {Pepoet prvn uivatelsk souadnice na svtovou}
    function  XCoor(x:Double):integer;
    {Pepoet druh uivatelsk souadnice na svtovou}
    function  YCoor(y:Double):integer;
    {Pepoet prvn svtov souadnice na uivatelskou}
    function  InvXCoor(x:Integer):Double;
    {Pepoet druh svtov souadnice na uivatelskou}
    function  InvYCoor(y:Integer):Double;
    {Sestroj bod ve svtovch souadnicch zadanou barvou}
    procedure PutPixel(X:TPixel;Red,Green,Blue:Byte);
    {Sestroj seku ve svtovch souadnicch zadanou barvou}
    procedure PixelLine(X,Y:TPixel;Red,Green,Blue:Byte);
     {Sestroj kek na uivatelskch souadnicch zadanou barvou}
    Procedure Cross(X:TPoint;Size,Red,Green,Blue:Byte);
    {Sestroj seku v uivatelskch souadnicch zadanou barvou}
    procedure Line(X,Y:TPoint;Red,Green,Blue:Byte);
   {Sestroj polygon prochzenc prvnmi n body zadanho pole zadanou barvou}
    procedure PolyLine(X:TArrayOfPoints;n:Word;Red,Green,Blue:Byte);
    {Sestroj seku v uivatelskch souadnicch zadanou barvou}
    procedure cvLine(X,Y:TPoint;Red,Green,Blue:byte);
    {Sestroj rovnobku s osou x zadanou barvou}
    Procedure XAxis(x1,x2,y:Double;Red,Green,Blue:byte);
    {Sestroj rovnobku s osou y zadanou barvou}
    Procedure YAxis(y1,y2,x:Double;Red,Green,Blue:byte);
    {Sestroj cejchovanou rovnobku s osou x zadanou barvou}
    Procedure XScale(x1,x2,y:Double;Red,Green,Blue:byte);
    {Sestroj cejchovanou rovnobku s osou y zadanou barvou}
    procedure YScale(y1,y2,x:Double;Red,Green,Blue:byte);

    Function PreCalc(Vstup:String;var Errorreport:String):TExpression;
    Function PostCalc(Vstup:TExpression;var ErrorReport:String):Double;
    Function Calc(Vstup:String;var ErrorReport:String):Double;

  end;

  Const Max     =255;                                    {maximalni dlka etzce}
      NoOfFunct=14;
      Digits  =['0'..'9','.'];
      BinOper =['^','*','/','+','-'];                        {binrn opertory}
      UnOper  =[#199..#211];                                  {unrn opertory}
      Functions :array [1..NoOfFunct] of string =
                    ('E','ABS','SIN','SQR','SQRT','COS','ARCTAN','ARCSIN','ARCCOS',
                   'EXP','LN','TAN','FA','PI');
      Letters = ['E','A','B','S','I','N','Q','R','T','C','O','K','N',
                                     'X','P','L','F','Y','Z'];
      Variables = ['K','N','R','S','T','X','Y','Z'];
      PractZero  = 1e-15;

  var
  Draw2D: TDraw2D;
  Unit_X,Unit_Y:Real;
  O            :TPoint;
  x1,x2,y1,y2,x,y,hx,hy,
    {parametr a jeho interval}
  t,t1,t2,ht,r,r1,r2,hr,s,s1,s2,hs,z,z1,z2,hz,
  k,k1,k2,hk,
    {argument a jeho interval - pro polrn souadnice}
  fi,fi1,fi2,hfi,n      :double;
  index        :Integer;
  Q            :TArrayOfPoints;


implementation

uses ControlPanel;

{$R *.DFM}

Procedure TDraw2D.InitImage(Width,Height:Integer);
begin
      Image1.Align:=alNone;
      Image1.Picture.Bitmap.PixelFormat:=pf24bit;
      Image1.Picture.Bitmap.Width:=Width;
      Image1.Picture.Bitmap.Height:=Height;
      Image1.Width:=Width;
      Image1.Height:=Height;
      Visible:=True;
end;

Procedure TDraw2D.ClearImage(Red,Green,Blue:Byte);
var i,j,Adr:Integer;
begin
  With Image1 do
  for j:=0 to Height-1 do
  begin
    PointOnScanRow:=Picture.Bitmap.ScanLine[j];
    for i:=0 to Width-1 do
    begin
      Adr:=3*i;
      PointOnScanRow[Adr]:=Blue;
      PointOnScanRow[succ(Adr)]:=Green;
      PointOnScanRow[succ(succ(Adr))]:=Red;
    end;
  end;
  Image1.Repaint;
end;


Procedure TDraw2D.Scale(x1,x2,y1,y2:Double);
  begin
     Unit_X:= Image1.Width/(x2-x1);
     Unit_Y:= Image1.Height/(y2-y1);
     O[1]  := -x1*Unit_X;
     O[2]  :=  y2*Unit_Y;
  end;

  function  TDraw2D.XCoor(x:Double):integer;
  begin
    XCoor:=trunc(O[1]+Unit_X*x);
  end;

  function  TDraw2D.YCoor(y:Double):integer;
  begin
     YCoor:=trunc(O[2]-Unit_Y*y);
  end;

  function  TDraw2D.InvXCoor(x:Integer):Double;
  begin
    InvXCoor:=(x-O[1])/Unit_X;
  end;

  function  TDraw2D.InvYCoor(y:Integer):Double;
  begin
     InvYCoor:=(O[2]-y)/Unit_Y;
  end;

 procedure TDraw2D.PutPixel(X:TPixel;Red,Green,Blue:Byte);
  var Adr:Integer;
  begin
      PointOnScanRow:=Image1.Picture.Bitmap.ScanLine[X[2]];
      Adr:=3*X[1];
      PointOnScanRow[Adr]:=Blue;
      PointOnScanRow[succ(Adr)]:=Green;
      PointOnScanRow[succ(succ(Adr))]:=Red;
  end;

   procedure TDraw2D.PixelLine(X,Y:TPixel;Red,Green,Blue:Byte);
  var p,p1,p2,Dx,Dy,i       :Integer;
      M                     :TPixel;
      Position              :Byte;
      Adr                   :Integer;
  Begin
  With Image1 do
  if (X[1]<0) or (X[1]>=Width) or (X[2]<0) or (X[2]>=Height) or
     (Y[1]<0) or (Y[1]>=Width) or (Y[2]<0) or (Y[2]>=Height) then exit;
  Dx:=Y[1]-X[1];
  if Dx<0 then
       begin
             p:=X[1];X[1]:=Y[1];Y[1]:=p;
             p:=X[2];X[2]:=Y[2];Y[2]:=p;
             Dx:=-Dx;
       end;
  Dy:=Y[2]-X[2];M[1]:=X[1];M[2]:=X[2];
  PointOnScanRow:=Image1.Picture.Bitmap.ScanLine[M[2]];
  Adr:=3*M[1];
  PointOnScanRow[Adr]:=Blue;
  PointOnScanRow[succ(Adr)]:=Green;
  PointOnScanRow[succ(succ(Adr))]:=Red;
  if (Dx=0) and (Dy=0) then exit;                                {jedin bod}
  if Dx=0 then
           if Dy>0 then Position:=1                           {svisle nahoru}
                   else Position:=2                             {svisle dolu}
          else
           if Dy=0 then Position:=3                           {zleva doprava}
            else
            if Dy=Dx then Position:=4                                   {k=1}
                    else
                     if Dy=-Dx then Position:=5                        {k=-1}
                               else
                               if Dy>0 then
                                       if Dy>Dx then Position:=6        {k>1}
                                                else Position:=7      {0<k<1}
                                        else
                                         if -Dy>Dx then Position:=8    {k<-1}
                                                   else Position:=9; {-1<k<0}
Case Position of
  {svisle nahoru}
  1: begin
     Adr:=3*M[1];
     For i:=succ(X[2]) to Y[2] do
            begin
              PointOnScanRow:=Image1.Picture.Bitmap.ScanLine[i];
             // Good:=Good and (PointOnScanRow[Adr]=200) and

              PointOnScanRow[Adr]:=Blue;
              PointOnScanRow[succ(Adr)]:=Green;
              PointOnScanRow[succ(succ(Adr))]:=Red;
            end;
     end;
  {svisle dol}
  2: begin
     Adr:=3*M[1];
     For i:=succ(Y[2]) to X[2] do
            begin
              PointOnScanRow:=Image1.Picture.Bitmap.ScanLine[i];
              PointOnScanRow[Adr]:=Blue;
              PointOnScanRow[succ(Adr)]:=Green;
              PointOnScanRow[succ(succ(Adr))]:=Red;
            end;
     end;
   {zleva doprava}
   3:begin
      PointOnScanRow:=Image1.Picture.Bitmap.ScanLine[M[2]];
      For i:=succ(X[1]) to Y[1] do
      begin
       Adr:=3*i;
       PointOnScanRow[Adr]:=Blue;
       PointOnScanRow[succ(Adr)]:=Green;
       PointOnScanRow[succ(succ(Adr))]:=Red;
      end;
    end;
   {k=1}
   4:For i:=succ(X[1]) to Y[1] do
            begin
              PointOnScanRow:=Image1.Picture.Bitmap.ScanLine[M[2]];
              Adr:=3*i;
              PointOnScanRow[Adr]:=Blue;
              PointOnScanRow[succ(Adr)]:=Green;
              PointOnScanRow[succ(succ(Adr))]:=Red;
              inc(M[2]);
            end;
   {k=-1}
   5:For i:=succ(X[1]) to Y[1] do
           begin
             PointOnScanRow:=Image1.Picture.Bitmap.ScanLine[M[2]];
             Adr:=3*i;
             PointOnScanRow[Adr]:=Blue;
             PointOnScanRow[succ(Adr)]:=Green;
             PointOnScanRow[succ(succ(Adr))]:=Red;
             dec(M[2]);
           end;
   {k>1}
   6:begin
       p:=Dx;Dx:=Dy;Dy:=p;
       p1:=2*Dy;p2:=2*(Dy-Dx);p:=2*Dy-Dx;
       While M[2]<Y[2] do
       begin
        Inc(M[2]);
        if p>0 then begin
                       Inc(M[1]);p:=p+p2;
                    end
                    else       p:=p+p1;
        PointOnScanRow:=Image1.Picture.Bitmap.ScanLine[M[2]];
        Adr:=3*M[1];
        PointOnScanRow[Adr]:=Blue;
        PointOnScanRow[succ(Adr)]:=Green;
        PointOnScanRow[succ(succ(Adr))]:=Red;
      end;
     end;
  {0<k<1}
  7: begin
       p1:=2*Dy;p2:=2*(Dy-Dx);p:=2*Dy-Dx;PointOnScanRow:=Image1.Picture.Bitmap.ScanLine[M[2]];
       While M[1]<Y[1] do
       begin
        inc(M[1]);
        if p>0 then begin
                      inc(M[2]);p:=p+p2;
                      PointOnScanRow:=Image1.Picture.Bitmap.ScanLine[M[2]];
                    end
                    else  p:=p+p1;
        Adr:=3*M[1];
        PointOnScanRow[Adr]:=Blue;
        PointOnScanRow[succ(Adr)]:=Green;
        PointOnScanRow[succ(succ(Adr))]:=Red;
       end;
      end;
  {k<-1}
  8: begin
       p:=Dx;Dx:=Dy;Dy:=-p;
       p1:=2*Dy;p2:=2*(Dy-Dx);p:=2*Dy-Dx;
       While M[2]>Y[2] do
       begin
        dec(M[2]);
        if p<0 then begin
                     inc(M[1]);p:=p+p2;
                    end
                    else       p:=p+p1;
        PointOnScanRow:=Image1.Picture.Bitmap.ScanLine[M[2]];
        Adr:=3*M[1];
        PointOnScanRow[Adr]:=Blue;
        PointOnScanRow[succ(Adr)]:=Green;
        PointOnScanRow[succ(succ(Adr))]:=Red;
      end;
     end;
  {-1<k<0}
  9: begin
       Dy:=-Dy;PointOnScanRow:=Image1.Picture.Bitmap.ScanLine[M[2]];
       p1:=2*Dy;p2:=2*(Dy-Dx);p:=2*Dy-Dx;
       While M[1]<Y[1] do
       begin
        inc(M[1]);
        if p>0 then begin
                      dec(M[2]);
                      p:=p+p2;
                      PointOnScanRow:=Image1.Picture.Bitmap.ScanLine[M[2]];
                    end
                    else  p:=p+p1;
        Adr:=3*M[1];
        PointOnScanRow[Adr]:=Blue;
        PointOnScanRow[succ(Adr)]:=Green;
        PointOnScanRow[succ(succ(Adr))]:=Red;
      end;
     end;
  end;
end;

Procedure TDraw2D.Cross(X:TPoint;Size,Red,Green,Blue:Byte);
var Pixel,A,B,C,D:TPixel;
begin
   Pixel[1]:=XCoor(X[1]);Pixel[2]:=YCoor(X[2]);
    if (Pixel[1]>=Size) and (Pixel[1]<Image1.Width-Size) and
       (Pixel[2]>=Size) and (Pixel[2]<Image1.Height-Size) then
   begin
   A[1]:=Pixel[1]-Size;A[2]:=Pixel[2];
   B[1]:=Pixel[1]+Size;B[2]:=Pixel[2];
   C[1]:=Pixel[1];  C[2]:=Pixel[2]-Size;
   D[1]:=Pixel[1];  D[2]:=Pixel[2]+Size;
   PixelLine(A,B,Red,Green,Blue);
   PixelLine(C,D,Red,Green,Blue);
   end;
   Image1.Repaint;
end;

procedure TDraw2D.Line(X,Y:TPoint;Red,Green,Blue:Byte);
var A,B  :TPixel;
  begin
     A[1]:=XCoor(X[1]);A[2]:=YCoor(X[2]);
     B[1]:=XCoor(Y[1]);B[2]:=YCoor(Y[2]);
     PixelLine(A,B,Red,Green,Blue);
  end;

 procedure TDraw2D.PolyLine(X:TArrayOfPoints;n:Word;Red,Green,Blue:Byte);
 var i:Word;
     A,B:TPixel;
 begin
   A[1]:=XCoor(X[0,1]);A[2]:=YCoor(X[0,2]);
   for i:=1 to n-1 do
   begin
     B[1]:=XCoor(X[i,1]);B[2]:=YCoor(X[i,2]);
    if (A[1]>=0) and (A[1]<Image1.Width) and
       (A[2]>=0) and (A[2]<Image1.Height) and
       (B[1]>=0) and (B[1]<Image1.Width) and
       (B[2]>=0) and (B[2]<Image1.Height) then
            PixelLine(A,B,Red,Green,Blue);
    A:=B;
   end;
 end;

procedure TDraw2D.cvLine(X,Y:TPoint;Red,Green,Blue:byte);
begin
     With Image1.Canvas do
     begin
       Pen.Color:=Red+256*Green+256*256*Blue;
       MoveTo(XCoor(X[1]),YCoor(X[2]));
       LineTo(XCoor(Y[1]),YCoor(Y[2]));
     end;
end;

 Procedure TDraw2D.XAxis(x1,x2,y:Double;Red,Green,Blue:Byte);
 Var A,B:TPoint;
 begin
    A[1]:=x1;A[2]:=y;B[1]:=x2;B[2]:=A[2];
    cvLine(A,B,Red,Green,Blue);
  end;

Procedure TDraw2D.YAxis(y1,y2,x:Double;Red,Green,Blue:Byte);
 Var A,B:TPoint;
  begin
    A[1]:=x;A[2]:=y1;B[1]:=A[1];B[2]:=y2;
    cvLine(A,B,Red,Green,Blue);
  end;

procedure TDraw2D.XScale(x1,x2,y:Double;Red,Green,Blue:Byte);
  var  AxisUnit        :Double;
       Text            :String;
       Lx,Exponent     :Integer;

   begin
   XAxis(x1,x2,y,Red,Green,Blue);
   Image1.Canvas.Font.Color:=Red+256*Green+256*256*Blue;
   Image1.Canvas.Pen.Color:=Red+256*Green+256*256*Blue;
   AxisUnit:=1E30;Lx:=0;Exponent:=30;
   While (x2-x1)/AxisUnit<3 do
    begin
       AxisUnit:=AxisUnit/10;Exponent:=Exponent-1;
    end;
   Lx:=0;
   if x1<0 then
     Repeat Lx:=Lx-1 Until AxisUnit*(Lx-1)<x1
           else
     Repeat Lx:=Lx+1 Until AxisUnit*(Lx+1)>x1;
   With Image1.Canvas do
   repeat
      MoveTo(XCoor(AxisUnit*Lx),YCoor(y)-3);
      LineTo(XCoor(AxisUnit*Lx),YCoor(y)+3);
      Str(Lx,Text);
      TextOut(XCoor(AxisUnit*Lx)+3,YCoor(y)+5,Text);
      Lx:=Lx+1;
   until AxisUnit*(Lx+1)>x2;
   Str(Exponent,Text);
   Image1.Canvas.TextOut(XCoor(x2)-40,YCoor(y)+5,'*10');
   Image1.Canvas.TextOut(XCoor(x2)-20,YCoor(Y)+1,Text);
   end;

procedure TDraw2D.YScale(y1,y2,x:Double;Red,Green,Blue:Byte);
   var AxisUnit        :Double;
       Text            :String;
       Ly,Exponent     :Integer;
   begin
   YAxis(y1,y2,x,Red,Green,Blue);
   Image1.Canvas.Font.Color:=Red+256*Green+256*256*Blue;
   Image1.Canvas.Pen.Color:=Red+256*Green+256*256*Blue;
   AxisUnit:=1E30;Ly:=0;Exponent:=30;
   While (y2-y1)/AxisUnit<3 do
    begin
       AxisUnit:=AxisUnit/10;Exponent:=Exponent-1;
    end;
   Ly:=0;
   if y1<0 then
     Repeat Ly:=Ly-1 Until AxisUnit*(Ly-1)<y1
           else
     Repeat Ly:=Ly+1 Until AxisUnit*(Ly+1)>y1;
   With Image1.Canvas do
   repeat
      MoveTo(XCoor(x)-3,YCoor(AxisUnit*Ly));
      LineTo(XCoor(x)+3,YCoor(AxisUnit*Ly));
      Str(Ly,Text);
      TextOut(XCoor(x)-25,YCoor(AxisUnit*Ly)-15,Text);
      Ly:=Ly+1;
   until AxisUnit*(Ly+1)>y2;
   Str(Exponent,Text);
   Image1.Canvas.TextOut(XCoor(x)+5,YCoor(y2)+10,'    ');
   Image1.Canvas.TextOut(XCoor(x)+5,YCoor(y2)+10,'*10');
   Image1.Canvas.TextOut(XCoor(x)+25,YCoor(y2)+3,Text);
   end;

procedure TDraw2D.SetPoint(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var A:TPoint;
begin
  A[1]:=InvXCoor(x);A[2]:=InvYCoor(y);
  Cross(A,10,0,200,0);
  Image1.Repaint;
  P[index,1]:=A[1];P[index,2]:=A[2];index:=succ(index);
end;

Function Prvek(Zapis:String;i:Integer; var Hodnota:Double; var Znak:Char;var PocetZnaku:Integer):Boolean;
//Funkce pro ten zpisu po prvcch.
//vrac true, pokud se jet etl znak
//vrac znak "$" pokud se etlo slo

var j,Code    :Integer;
begin
    if i>Length(zapis)
          then Prvek:=False
          else begin
                 Prvek:=True;
                 if Zapis[i] in digits
                 then begin
                           Znak:='$'; {na vstupu je slo}
                           j:=i;
                           Repeat
                             inc(i);
                             if Zapis[i]='E' then inc(i);
                             if ((Zapis[i]='+') or (Zapis[i]='-')) and (Zapis[pred(i)]='E')
                                             then inc(i);
                           Until not(Zapis[i] in Digits);
                           PocetZnaku:=i-j;
                           Val(Copy(Zapis,j,i-j),Hodnota,Code);
                           if Code>0 then begin Znak:='#';exit;end;
                        end
                    else Znak:=Zapis[i]; {Precte jiny znak}
               end;
end;

//Pomocn funkce pro vyslen etezce

Function FunctionReplacement(Vstup:String):String;
// funkce zamuje zpisy matematickch funkc za jednopismenove priznaky
var i,j,k,Left,Right :Integer;
    Vystup,Vypis     :String;
begin
  for i:=1 to length(Vstup) do Vstup[i]:=UpCase(Vstup[i]);

   i:=0;
  Repeat
   inc(i);
   if Vstup[i]=',' then Vstup[i]:='.';
   if not (Vstup[i] in Letters+BinOper+Digits+['(',')']) then
     begin
       FunctionReplacement:='Chybny vyraz';exit;
     end;
  until i=length(Vstup);

  Left:=0;Right:=0;

  i:=0;
  Repeat
     inc(i);
     Case Vstup[i] of
    '.'                 : if (not (Vstup[pred(i)] in Digits)) or
                             (not (Vstup[succ(i)] in Digits)) then
                           begin
                              FunctionReplacement:='Chybny vyraz';exit;
                           end;
    '('                 :inc(Left);
    ')'                 :inc(Right);
    '^','*','/','+','-' :if (Vstup[succ(i)] in binoper+[')']) then
                         begin
                           FunctionReplacement:='Chybny vyraz';exit;
                         end;
    'A','E','F','S','N','R','T','L','C',
    'K','X','P','Y','Z':begin
                          Vypis:=Vstup[i];
                          j:=succ(i);
                          While Vstup[j] in Letters do
                            begin Vypis:=Vypis+Vstup[j];inc(j);end;
                          if j=succ(i)
                            then begin
                                  if (not (Vstup[i] in Variables))
                                   then
                                    begin
                                      FunctionReplacement:='Chybny vyraz';exit;
                                    end;
                                 end
                            else begin
                             k:=0;
                             Repeat
                               inc(k);
                             until (Vypis=Functions[k]) or (k=pred(NoOfFunct));
                             if Vypis<>'PI' then
                             if (Vypis<>Functions[k]) or (Vstup[j]<>'(')
                             then begin
                                    FunctionReplacement:='Chybny vyraz';exit;
                                  end
                          end;
                          i:=pred(j);
                         end;
      '0'..'9'         :begin
                        end;
      else begin
            FunctionReplacement:='Chybny vyraz';exit;
           end;
    end;
 until i=Length(Vstup);
 if Left<>Right then
      begin
       FunctionReplacement:='Chybny vyraz';exit;
     end;

  Vystup:='';
  i:=1;
  Repeat
       Case Vstup[i] of
        {funkce}
       '-':  begin
             if (i=1) or (Vstup[i-1]='(')
                                      then Vystup:=Vystup + #199  {unrn minus}
                                      else Vystup:=Vystup + Vstup[i];
              inc(i);
             end;
       '+':  begin
             if (i=1) or (Vstup[i-1]='(')
                                      then Vystup:=Vystup          {unrn plus}
                                      else Vystup:=Vystup + Vstup[i];
              inc(i);
             end;
       'S': Case Vstup[i+2] of
               'N':begin Vystup:=Vystup + #200;                          {sinus}
                         i:=i+3;
                   end;
               'R':begin
                   if Vstup[i+3]='T'
                   then begin Vystup:=Vystup + #207;i:=i+4;end {druha odmocnina}
                   else begin Vystup:=Vystup + #206;i:=i+3;end   {druha mocnina}
                   end;
               else begin Vystup:=Vystup+'S';inc(i);end;            {promnn S}
               end;
       'C':if Vstup[succ(i)]='O'
               then begin Vystup:=Vystup + #201;i:=i+3;end;            {cosinus}
       'A':Case Vstup[i+3] of
                'T':begin Vystup:=Vystup + #204;i:=i+6;end;             {arctan}
                'S':begin Vystup:=Vystup + #209;i:=i+6;end;             {arcsin}
                'C':begin Vystup:=Vystup + #210;i:=i+6;end              {arccos}
                 else begin Vystup:=Vystup + #208;i:=i+3;end;              {abs}
               end;
       'E':begin Vystup:=Vystup + #202;i:=i+3;end;                         {exp}
       'L':begin Vystup:=Vystup + #203;i:=i+2;end;                          {ln}
       'T':if Vstup[succ(i)]='A'
             then begin Vystup:=Vystup + #205;i:=i+3;end                   {tan}
             else begin Vystup:=Vystup+'T';inc(i);end;              {promnn T}
       'F':begin Vystup:=Vystup + #211;i:=i+2;end;              {fa - faktoril}
       'P':begin Vystup:=Vystup+'P';i:=i+2;end;                  {Konstanta pi}
       {Promnn}
       'X':begin Vystup:=Vystup+'X';inc(i);end;                     {promnn X}
       'Y':begin Vystup:=Vystup+'Y';inc(i);end;                     {promnn Y}
       'Z':begin Vystup:=Vystup+'Z';inc(i);end;                     {promnn Z}
       'R':begin Vystup:=Vystup+'R';inc(i);end;                     {promnn R}
       'N':begin Vystup:=Vystup+'N';inc(i);end;                     {promnn N}
       'K':begin Vystup:=Vystup+'K';inc(i);end;                     {promnn K}
        else begin Vystup:=Vystup + Vstup[i];inc(i);end
       end;                                                               {Case}
  Until i>Length(Vstup);
  FunctionReplacement:=Vystup;
end;

Function TDraw2D.PreCalc(Vstup:String;var Errorreport:String):TExpression;
Const Max = 255;                                     {maximalni pocet operatoru}
      NotInit = 0;                                    {neinicializovana hodnota}
var   Zasobnik  : TExpression;                               {Pracovni zasobnik}
      W         : 0..Max;                                     {Vrchol zasobniku}
      H         : Double;                                     {hodnoty operand}
      Z         : Char;                                         {znak na vstupu}
      Pokracovat: Boolean;
      i,j,Pocet : Integer;
      VypisCisla:String;
      Vystup    :TExpression;
      Term      :TTerm;
begin
  VypisCisla:=Vstup;
  Vstup:=FunctionReplacement(Vstup);
  if (vstup='Chybny vyraz') or
     (vstup='Chybne cislo') then
     begin
       ErrorReport:=Vstup;
       exit;
     end;
  For j:=1 to max do
      With Vystup[j] do begin Value:=NotInit;Character:='%';end;
  w:=0;i:=1;j:=0;
  Pokracovat:=Prvek(Vstup,i,H,Z,Pocet);
  While Pokracovat do
  begin
   Case Z of
   '$':With Vystup[j] do
       begin                                                {na vstupu je cislo}
             Value:=H;Character:='$';
             inc(j);
             i:=i+Pocet;
       end;
   '#':begin ErrorReport:='Chybne cislo';                         {chybne cislo}
             exit;
       end;
   'P':With Vystup[j] do
       begin                                                   {na vstupu je pi}
             Value:=Pi;Character:='$';inc(j);inc(i);
       end;
   'K','N','R','S','T','X','Y','Z':
       With Vystup[j] do
       begin                                             {na vstupu je promenna}
             Value:=NotInit;Character:=Z;inc(j);inc(i);
       end;
   '(':begin                                              {zavorku do zasobniku}
             inc(W);
             Term.Character:='(';Term.Value:=NotInit;
             Zasobnik[w]:=Term;inc(i);
       end;
   ')':begin                                  {z vrcholu zasobniku az k zavorce}
         while (w>0) and (Zasobnik[w].Character<>'(') do
           begin  Vystup[j]:=Zasobnik[w];inc(j);dec(w) end;
           if w=0 then begin Errorreport:='Chybny vyraz';exit;end
                  else dec(w);                                 {zruseni zavorky}
         inc(i);
       end;
 ' ' :inc(i);
 #200..#211:                    {operatory nejvyssi priority - ven ze zasobniku}
       begin
         while (w>0) and (Zasobnik[w].Character in [#200..#211]) do
             begin
                   Vystup[j]:=Zasobnik[w];
                   inc(j);dec(w) end;
             inc(w);Term.Character:=Z;Term.Value:=NotInit;
             Zasobnik[w]:=Term;                          {znak do zasobniku}
           inc(i);
       end;

 '^' :  begin                                       {mocnina - ven ze zasobniku}
           while
           (w>0) and ((Zasobnik[w].Character='^') or (Zasobnik[w].Character in [#200..#211])) do
             begin Vystup[j]:=Zasobnik[w];inc(j);dec(w) end;
             inc(w);
             Term.Character:=Z;Term.Value:=NotInit;
             Zasobnik[w]:=Term;                              {znak do zasobniku}
           inc(i);
         end;

 '/','*':begin                     {operatory nizsi priority - ven ze zasobniku}
           while (w>0) and (Zasobnik[w].Character in [#200..#211,'*','/','^']) do
             begin Vystup[j]:=Zasobnik[w];inc(j);dec(w) end;
             inc(w);Term.Character:=Z;Term.Value:=NotInit;
             Zasobnik[w]:=Term;                              {znak do zasobniku}
           inc(i);
         end;
  #199:  begin                                                   {unarni minus}
           while (w>0) and (Zasobnik[w].Character in [#200..#211,'+','-','*','/','^']) do
           begin
             Vystup[j]:=Zasobnik[w];
             inc(j);dec(w)
           end;
             inc(w);Term.Character:=Z;Term.Value:=NotInit;
             Zasobnik[w]:=Term;                             {znak do zasobniku}
             inc(i);
           end;
 '+','-':begin                  {operatory nejnizsi priority - ven ze zasobniku}
           while (w>0) and (Zasobnik[w].Character in [#199..#211,'+','-','*','/','^']) do
             begin Vystup[j]:=Zasobnik[w];inc(j);dec(w) end;
             inc(w);Term.Character:=Z;Term.Value:=NotInit;
             Zasobnik[w]:=Term;                              {znak do zasobniku}
           inc(i);
         end;
 
     end; {Case}
    Pokracovat:=Prvek(Vstup,i,H,Z,Pocet);
  end;
  While (w>0) and (Zasobnik[w].Character<>'(') do
       begin                              {vyprazdnit pripadny zbytek zasobniku}
        Vystup[j]:=Zasobnik[w];inc(j);dec(w);
       end;
  PreCalc:=Vystup;
  if w>0 then Errorreport:='Chybny vyraz'
         else Errorreport:='';
end;                                                       {Procedure PreExpres}

Function TDraw2D.PostCalc(Vstup:TExpression;var ErrorReport:String):Double;
var   Zasobnik,ZZZ  : TExpression;                 {zsobnk na hodnoty}
      i,w       : Integer;
      H,H1,H2   :Double;

Function Faktorial(N:LongInt):LongInt;
begin
   if n>1 then Faktorial:=n*Faktorial(pred(n))
          else Faktorial:=1;
end;

Function Mocnina(Zaklad:Double;Exponent:LongInt):Double;
var i:LongInt;
    Moc:Double;
begin
  Moc:=1;
  for i:=1 to abs(Exponent) do Moc:=Moc*Zaklad;
  if Exponent<0 then Moc:=1/Moc;
  Mocnina:=Moc;
end;

begin
  if (ErrorReport='Chybny vyraz')
      or (ErrorReport='Chybne cislo') then Exit;
  ErrorReport:='';
  w:=-1;i:=0;
  While (Vstup[i].Character<>'%') do
  begin
    Case Vstup[i].Character of
   '$':begin inc(w);                                        {na vstupu je cislo}
             Zasobnik[w]:=Vstup[i];
             inc(i);
       end;
   'K','N','R','S','T','X','Y','Z':                      {na vstupu je promenna}
       begin
            inc(w);
            Case Vstup[i].Character of
            'K': Vstup[i].Value:=K;
            'N': Vstup[i].Value:=N;
            'R': Vstup[i].Value:=R;
            'S': Vstup[i].Value:=S;
            'T': Vstup[i].Value:=T;
            'X': Vstup[i].Value:=X;
            'Y': Vstup[i].Value:=Y;
            //'Z': Vstup[i].Value:=Z;
            end;
           Zasobnik[w]:=Vstup[i];
           inc(i);
       end;
     '^','/','*', '+','-':             {binrn opertory}
        begin
          H1:=Zasobnik[w].Value;
          dec(w);
          H2:=Zasobnik[w].Value;
           Case Vstup[i].Character of
            '^':begin
                 {H2^H1}
                 if (Abs(H2)<PractZero) and (H1<0) then
                    begin
                      ErrorReport:='Neppustn zklad reln mocniny';
                      exit;
                    end
                 else
                 if (H1<0) and (H1=Round(h1))
                          then Zasobnik[w].Value:=Mocnina(H2,Round(H1))
                     else if H1=Round(h1)
                        then Zasobnik[w].Value:=Mocnina(H2,Round(H1))
                          else if h2>PractZero
                              then Zasobnik[w].Value:=exp(H1*ln(H2))
                              else begin
                                    ErrorReport:='Neppustn zklad reln mocniny';
                                    exit;
                                   end;
                end;
            '/':begin
                  if Abs(H1)<PractZero
                   then begin
                          ErrorReport:='Dlen nulou';
                          exit;
                        end
                        else Zasobnik[w].Value:=H2 /   H1;
                end;
            '*':Zasobnik[w].Value:=H2 *   H1;
            '+':Zasobnik[w].Value:=H2 +   H1;
            '-':Zasobnik[w].Value:=H2 -   H1;
            end;
            inc(i);
          end;
                                           {funkce}
        #199:begin
              inc(i);Zasobnik[w].Value:=-Zasobnik[w].Value;      {unrn minus}
             end;
        #200:begin
              inc(i);Zasobnik[w].Value:=sin(Zasobnik[w].Value);          {sinus}
             end;
        #201:begin
              inc(i);Zasobnik[w].Value:=cos(Zasobnik[w].Value);        {cosinus}
             end;
        #202:begin
              inc(i);Zasobnik[w].Value:=exp(Zasobnik[w].Value);            {exp}
             end;
        #203:begin
              inc(i);
              if Zasobnik[w].Value>PractZero
                          then Zasobnik[w].Value:=ln(Zasobnik[w].Value)     {ln}
                          else begin
                                ErrorReport:='Neppustn argument logaritmu';
                                exit;
                               end;
             end;
        #204:begin
              inc(i);Zasobnik[w].Value:=arctan(Zasobnik[w].Value);      {arctan}
             end;
        #205:begin
              inc(i);                                                  {tangens}
              if abs(cos(Zasobnik[w].Value))>PractZero
                            then Zasobnik[w].Value:=sin(Zasobnik[w].Value)/cos(Zasobnik[w].Value)
                            else begin
                                  ErrorReport:='Nedefinovan tangens';
                                  exit;
                                 end;
             end;
        #206:begin
              inc(i);Zasobnik[w].Value:=sqr(Zasobnik[w].Value);{druh mocnina}
             end;
        #207:begin
              inc(i);                                          {druh odmocnina}
              if Zasobnik[w].Value>=0
                      then Zasobnik[w].Value:=sqrt(Zasobnik[w].Value)
                      else begin
                           ErrorReport:='Zporn argument odmocniny';
                           exit;
                           end;
             end;
        #208:begin
              inc(i);Zasobnik[w].Value:=Abs(Zasobnik[w].Value);{absolutn hodnota}
             end;
        #209:begin                                                 {arcus sinus}
              inc(i);
              if abs(Zasobnik[w].Value)<1
                then Zasobnik[w].Value:=
                 arctan(Zasobnik[w].Value/sqrt(1-Zasobnik[w].Value*Zasobnik[w].Value))
                else if Zasobnik[w].Value=-1
                    then Zasobnik[w].Value:=-pi/2
                    else if Zasobnik[w].Value=1
                        then Zasobnik[w].Value:=pi/2
                        else begin
                              ErrorReport:='Neppustn argument arcsin';
                              exit;
                             end;
             end;
        #210:begin                                               {arcus cosinus}
              inc(i);
              if abs(Zasobnik[w].Value)<1
                then Zasobnik[w].Value:=pi/2-arctan(Zasobnik[w].Value/sqrt(1-Zasobnik[w].Value*Zasobnik[w].Value))
                else if Zasobnik[w].Value=-1
                    then Zasobnik[w].Value:=pi
                    else if Zasobnik[w].Value=1
                        then Zasobnik[w].Value:=0
                        else begin
                              ErrorReport:='Neppustn argument arccos';
                              exit;
                             end;
             end;
        #211:begin                                                   {faktoril}
               inc(i);
               if (Zasobnik[w].Value>=0) and (Round(Zasobnik[w].Value)=Zasobnik[w].Value)
                  then Zasobnik[w].Value:=Faktorial(Round(Zasobnik[w].Value))
                  else begin
                        ErrorReport:='Neppustn argument faktorilu';
                        exit;
                       end;
             end;
         end;                                                           {Case Z}
        end;
  if w>0 then ErrorReport:='Chybn vraz';
  PostCalc:=Zasobnik[w].Value;
end;                                                                {PostExpres}

Function TDraw2D.Calc(Vstup:String;var ErrorReport:String):Double;
var Expression:TExpression;
begin
  Expression:=PreCalc(Vstup,ErrorReport);
  Calc:=PostCalc(Expression,ErrorReport);
end;

end.
